#!/usr/bin/perl -Tw
#
# Copyright (C) Joseph Heenan 2005

use strict;
use CGI qw(:standard);

my $width = 400;
my $height = $width * 576 / 768; # keep 768 x 576 aspect ratio
my $quality = 60;
my $device = ""; # change to, eg, "-c /dev/video1" if you want to use a tv card other than the default
exit main();

sub main
{
    my $jpgfname;
    my $ppmfname;
    my $cmd;
    my $ret;
   
    # write file to cwd
    $ppmfname = "capture.tmp.$$.ppm";
    $jpgfname = "capture.tmp.$$.jpg";
    $ENV{PATH} = "/usr/local/bin:/usr/bin:/bin";

    # uncomment this block of text if you need to explictly set the tv card input
    $cmd = "v4lctl $device setinput s-video";
    $ret = system($cmd);
    if ($ret != 0)
    {
        die "Can't run '$cmd' ($ret)";
    }

    $cmd = "v4lctl $device snap ppm ${width}x${height} $ppmfname";
    $ret = system($cmd);
    if ($ret != 0)
    {
        die "Can't run '$cmd' ($ret)";
    }

    $cmd = "ppmtojpeg --smooth 10 --quality $quality --progressive $ppmfname ".
      "> $jpgfname";
    $ret = system($cmd);
    unlink $ppmfname;
    if ($ret != 0)
    {
        die "Can't run '$cmd' ($ret)";
    }

    open(FH, $jpgfname) or die "Can't open $jpgfname";
    binmode FH;

    print "Content-Type: image/jpeg\r\n\r\n";

    # read in the entire file
    my $oldsep = $/;
    undef $/;
    my $data = <FH>;
    $/ = $oldsep;
    close(FH);
    
    print $data;
    
    unlink $jpgfname;
}
